=begin
(c) TIG 2012
All Rights Reserved.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
WARRANTIES,INCLUDING,WITHOUT LIMITATION,THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
###
Script:
shortcutPlist2Dat.rb
###
Takes a MAC's Shortcuts.plist file and makes it into a PC useable .dat file.
###
Usage:
Type in the Ruby Console...
  TIG.shortcutPlist2Dat
Follw the prompts...
###
Donations: by PayPal.com to info @ revitrev.org
###
Version:
1.0 20120528 First issue.
1.1 20120528 Three mod-keys options included.
###
NOTE:
0 = no modifier
131072 = Shift
262144 = Control
524288 = Option
1048576 = Apple
=end
require 'sketchup.rb'
###
module TIG

def self.shortcutPlist2Dat()
  plist=UI.openpanel("Choose Shortcuts.PLIST to make .DAT...",Dir.pwd,"*.plist")
  return nil unless plist
  plistlines=IO.readlines(plist)
  lines=[]
  plistlines.each{|line|
    next unless line=~/<string>/ or line=~/<integer>/
    lines << line
  }
  shortcuts=[]
  str=0
  key=nil
  mod=nil
  tool=nil
  txt=""
  lines.each{|line|
    if line=~/<string>/
      if str==0
        line="~"+line
        key=(line.split("<string>")[1].split("</string>")[0]).upcase
        key="Space" if key==" "
        txt=key
        str+=1
      elsif str==1
        line="~"+line
        tool=line.split("<string>")[1].split("</string>")[0]
        txt=txt+" "+tool
        str+=1
      end
    elsif line=~/<integer>/
      mod=line.split("<integer>")[1].split("</integer>")[0]
      opts="0 0 0 "
      if mod=="0" ####= no modifier
        opts="0 0 0 "
      elsif mod=="131072" ###= Shift
        opts="0 0 1 "
      elsif mod=="262144" ###= Control
        opts="1 0 0 "
      elsif mod=="524288" ###= Option
        opts="0 1 0 "
      elsif mod=="1048576" ###= Apple
        opts="1 0 0 "
      elsif mod=="393216" ### Shift+Control
        opts="1 0 1 "
      elsif mod=="655360" ### Shift+Option
        opts="0 1 1 "
      elsif mod=="1179648" ### Shift+Apple
        opts="1 0 1 "
      elsif mod=="786432" ### Control+Option
        opts="1 1 0 "
      elsif mod=="1441792" ### Control+Apple
        opts="1 0 0 "
      elsif mod=="1572864" ### Option+Apple
        opts="1 1 0 "
      elsif mod=="917504" ### Shift+Control+Option
        opts="1 1 1 "
      elsif mod=="1703936" ### Shift+Option+Apple
        opts="1 1 1 "
      end
      txt=opts+txt
    end
    if str > 1
      shortcuts << txt
      str=0
    end
  }
  dat=File.join(File.dirname(plist), File.basename(plist, ".*")+".DAT")
  f=File.open(dat, "w")
  f.puts("[Accelerator]\nCount="+shortcuts.length.to_s)
  shortcuts.each{|txt|f.puts(txt)}
  f.close
  puts dat.tr("\\","/")+" written."
end

end
###
